"{ Package: 'jv:calipel/s' }"

LibraryDefinition subclass:#jv_calipel_s
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'* Projects & Packages *'
!


!jv_calipel_s class methodsFor:'accessing - tests'!

testSuite
    | tests |

    tests := self package , '/tests'.
    Smalltalk loadPackage: tests.
    ^(ProjectDefinition definitionClassForPackage: tests) testSuite

    "Created: / 09-06-2013 / 22:23:31 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!jv_calipel_s class methodsFor:'description'!

excludedFromPreRequisites
    "list all packages which should be ignored in the automatic
     preRequisites scan. See #preRequisites for more."

    ^ #(
        #'stx:goodies/monticello'    "MCDirectoryRepository - referenced by jv_calipel_s class>>monticelloExportTo: "
        #'stx:libscm/mercurial/monticello'    "HGMCVersionInfo - referenced by jv_calipel_s class>>monticelloExportTo: "
    )
!

mandatoryPreRequisites
    "list all required mandatory packages.
     Packages are mandatory, if they contain superclasses of the package's classes
     or classes which are extended by this package.
     This list can be maintained manually or (better) generated and
     updated by scanning the superclass hierarchies
     (the browser has a menu function for that)"

    ^ #(
        #'stx:libbasic'    "LibraryDefinition - superclass of jv_calipel_s "
    )
!

referencedPreRequisites
    "list all packages containing classes referenced by the packages's members.
     This list can be maintained manually or (better) generated and
     updated by looking for global variable accesses
     (the browser has a menu function for that)
     However, often too much is found, and you may want to explicitely
     exclude individual packages in the #excludedFromPreRequisites method."

    ^ #(
        #'jv:calipel/s/stx'
    )
!

subProjects
    "list packages which are known as subprojects.
     The generated makefile will enter those and make there as well.
     However: they are not forced to be loaded when a package is loaded;
     for those, redefine requiredPrerequisites"

    ^ #(
        #'jv:calipel/s/benchmarks'
        #'jv:calipel/s/stx'
        #'jv:calipel/s/benchmarks/game'
        #'jv:calipel/s/tests'
        #'jv:calipel/s/benchmarks/micro'
    )
! !

!jv_calipel_s class methodsFor:'description - actions'!

postLoadAction
    "invoked after loading a project"

    Smalltalk loadPackage: (self package , '/stx')

    "Created: / 09-06-2013 / 22:21:54 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!jv_calipel_s class methodsFor:'description - contents'!

classNamesAndAttributes
    "lists the classes which are to be included in the project.
     Each entry in the list may be: a single class-name (symbol),
     or an array-literal consisting of class name and attributes.
     Attributes are: #autoload or #<os> where os is one of win32, unix,..."

    ^ #(
        "<className> or (<className> attributes...) in load order"
        BenchmarkInstance
        BenchmarkOutcome
        BenchmarkPlatform
        BenchmarkReport
        BenchmarkReportJSONWriter
        BenchmarkResult
        BenchmarkRunner
        BenchmarkSuite
        #'jv_calipel_s'
        BenchmarkReportJSON
        BenchmarkReportText
        BenchmarkRunnerResult
    )
!

extensionMethodNames
    "lists the extension methods which are to be included in the project.
     Entries are 2-element array literals, consisting of class-name and selector."

    ^ #(
    )
! !

!jv_calipel_s class methodsFor:'utilities - monticello'!

monticelloExportTo: directory
    "Export .mcz packages to given directory"

    | packages exporter mcrepo |

   packages := #(
        'jv:calipel/s'
        'jv:calipel/s/benchmarks/micro'
        'jv:calipel/s/benchmarks/game'
        'jv:calipel/s/tests'
    ).

    exporter := [:pkgnm|
        | mcpkg mcwc mcvi mcversion |

        mcpkg := MCPackage named: pkgnm.
        mcwc := mcpkg workingCopy.
        mcvi := HGMCVersionInfo forPackage: pkgnm.
        [
           mcversion := mcwc newVersion
        ] on: MCVersionNameAndMessageRequest do:[:ex |
            ex resume: (Array with: mcvi name with: mcvi message)
        ].
        mcversion info: mcvi.
        mcrepo storeVersion: mcversion.
    ].

    mcrepo := MCDirectoryRepository new directory: directory.
    packages do: exporter.

    "Created: / 11-06-2013 / 02:06:08 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!jv_calipel_s class methodsFor:'documentation'!

version_HG
    ^ '$Changeset: <not expanded> $'
!

version_MC
    ^ 'CalipeL_S-Core-JanVrany.7 5c300a20-c9d7-11e2-a959-606720e43e2c 2013-05-31T10:49:17 JanVrany'
! !

