"{ Package: 'jv:calipel/s/stx' }"

BenchmarkPlatform subclass:#BenchmarkPlatformStX
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'CalipeL-S-Smalltalk/X'
!

!BenchmarkPlatformStX class methodsFor:'documentation'!

documentation
"
 Replace 'StandaloneStartup', 'NewClass1' and
 the empty string arguments by true values.

 Install (or change) the class by 'accepting',
 either via the menu or the keyboard (usually CMD-A).

 You can also change the category simply by editing
 the categoryString and accepting.

 To be nice to others (and yourself later), do not forget to
 add some documentation; preferably under the classes documentation
 protocol.
 (see the `create documentation stubs' item in the methodList menu;
  switch from instance to class to find this menu item.)

 Notice, that ST/X uses the convention to document the class using
 comment-only class methods (however, ST80 comments are supported and
 can be changed via the class-documentation menu).

"
! !

!BenchmarkPlatformStX class methodsFor:'initialization'!

initialize
    "Invoked at system start or when the class is dynamically loaded."

    "Set stack size to 16MB"
    Processor activeProcess setMaximumStackSize: ((1024 * 1024 * 16) max: Process 
    defaultMaximumStackSize).

    "Setup for performance"
    JavaNativeMethod cacheNativeImplementation: true.

    ObjectMemory justInTimeCompilation: true.
    ObjectMemory javaNativeCodeOptimization: true.
    ObjectMemory javaJustInTimeCompilation: true.

    "ObjectMemory newSpaceSize: ObjectMemory newSpaceSize * 5."


    Current := self new.

    "Modified (comment): / 06-06-2013 / 09:14:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkPlatformStX methodsFor:'accessing-performance counters'!

millisecondTime
    ^OperatingSystem getMillisecondTime

    "Created: / 06-06-2013 / 09:30:05 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkPlatformStX methodsFor:'acessing-streams'!

stderr
    ^Stderr

    "Created: / 06-06-2013 / 09:30:23 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

stdout
    ^Stdout

    "Created: / 06-06-2013 / 09:30:20 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkPlatformStX methodsFor:'configuration'!

configurationStringOS
    "superclass BenchmarkPlatform says that I am responsible to implement this method"

    | sysinfo |

    sysinfo := OperatingSystem getSystemInfo.

    ^(sysinfo at: #system) 
        , ' ' ,  (sysinfo at: #release)
        , ' ' ,  (sysinfo at: #machine)

    "Modified: / 22-06-2013 / 23:01:42 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

configurationStringRuntime
    "superclass BenchmarkPlatform says that I am responsible to implement this method"

    | runtime |

    runtime := 'Smalltalk/X ' ,
            Smalltalk majorVersionNr printString ,
            '.',
            Smalltalk minorVersionNr printString ,
            '.',
            Smalltalk revisionNr printString.

    (Smalltalk versionString includesSubString: 'jv') ifTrue:[
        runtime := runtime , 'jv'
    ].
    ^runtime

    "Modified: / 22-06-2013 / 23:05:58 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkPlatformStX methodsFor:'exit'!

exit: code
    Smalltalk exit: code.

    "Created: / 06-06-2013 / 09:14:50 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkPlatformStX methodsFor:'queries'!

isHeadless
    ^ Transcript isNil or:[Transcript isView not].

    "Created: / 06-06-2013 / 09:23:22 / Jan Vrany <jan.vrany@fit.cvut.cz>"
!

isSmalltalkX
    ^ true

    "Created: / 06-06-2013 / 09:39:40 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkPlatformStX methodsFor:'running'!

warmUpPost
    "Called after benchmark's warmup"

    ObjectMemory garbageCollect; tenure.

    "Created: / 07-06-2013 / 02:09:17 / Jan Vrany <jan.vrany@fit.cvut.cz>"
! !

!BenchmarkPlatformStX class methodsFor:'documentation'!

version_HG

    ^ '$Changeset: <not expanded> $'
! !


BenchmarkPlatformStX initialize!
