#!/bin/sh

TOP=../../../..

DEBUGGER=
PROFILER=
SMALLTALK_OPTS=
PROFILER_OPTS=
VM_OPTS=
VM=$TOP/stx/projects/smalltalk/stx

# On Windows use stx.com rather than stx.exe as exe has co
# console output

if [ ! -z "$OS" ]; then
    if [ "$OS" == "Windows_NT" ]; then
        VM=$VM.com
    fi
fi

if [ "$1" = "--help" ]
then
    echo <<ENDHELP
  --gdb ................... run benchmark under gdb debugger. Start with
                            (gdb) r -I -f "$DIR/benchmark-runner.st" -b ...
  --cgdb .................. run benchmark under cgdb debugger
  --callgrind ............. run benchmark under callgrind profiler.
ENDHELP
    "$VM" -I  -f "$DIR/benchmark-runner.st" ${1+"$@"}
# .........................
fi


while [ ! -z "$1" ]; do
    case "$1" in
        --gdb)
            DEBUGGER=gdb
            ;;
        --cgfb)
            DEBUGGER=gdb
            ;;
        --callgrind)
            #PROFILER="/usr/local/bin/valgrind -v -v -d --tool=callgrind --instr-atstart=no"
            PROFILER="/usr/local/bin/valgrind -v --smc-check=all-non-file --tool=callgrind --instr-atstart=no"
            PROFILER="valgrind -v --smc-check=all-non-file --tool=callgrind --instr-atstart=no"
            #PROFILER_OPTS=--callgrind
            ;;
        -T*)
            VM_OPTS="$VM_OPTS $1"
            ;;
        -M*)
            VM_OPTS="$VM_OPTS $1"
            ;;
        *)
            SMALLTALK_OPTS="$SMALLTALK_OPTS $1"
            ;;
    esac
    shift
done




DIR=`dirname $0`
if [ ! -z "$DEBUGGER" ]; then
    exec $DEBUGGER $VM
fi
if [ ! -z "$PROFILER" ]; then
    exec $PROFILER $VM \
        $VM_OPTS \
        -I -f "$DIR/benchmark-runner.st" \
        $SMALLTALK_OPTS
fi


exec "$VM" \
    $VM_OPTS \
    -I  -f "$DIR/benchmark-runner.rc" \
    $SMALLTALK_OPTS
