# == Schema Information
#
# Table name: benchmark_batches
#
#  id               :integer          not null, primary key
#  performed_at     :datetime
#  created_at       :datetime
#  updated_at       :datetime
#  configuration_id :integer
#

class BenchmarkBatch < ActiveRecord::Base

  has_many :benchmark_results, dependent: :destroy, inverse_of: :benchmark_batch
  belongs_to :benchmark_configuration, inverse_of: :benchmark_batches

  validates_presence_of :performed_at

  def result_for(info)
    benchmark_results.where(benchmark_info: info).first
  end

end
