class CompareQuery
  include ActiveModel::Model

  attr_accessor :benchmark_id, :benchmark_configurations

  def initialize(*args)
    super
    @benchmark_configurations ||= {}
  end

  def filtered_benchmark_configurations
    BenchmarkConfiguration.where(id: benchmark_configurations_to_array_of_ids)
  end

  def benchmark_info
    BenchmarkInfo.find(benchmark_id)
  end

  private

  def benchmark_configurations_to_array_of_ids
    benchmark_configurations.keys
  end
end
